Unit SF22R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTSF10_p;

function SF22R(X :Real; Y :Real; var IERR :Integer): Real;

implementation

function SF22R(X :Real; Y :Real; var IERR :Integer): Real;
var
J :Integer;
YY,AA,BB,C,B,G,D :Extended;
A :Array [0..2] of Real;
const
D20T4 :Real = 20.4;
SYS059 :Real = 3.4E38;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16,_17,_18;
begin
IERR := 0; // 
{ Result -    SF22R  FORTRANe }
A[0] := X;
A[1] := Y;
A[2] := X+Y;
AA := 1.0;
BB := 0.0;
for J:=1 to 3 do
 begin
  YY := A[J-1];
  if ( YY = 0.0 ) 
   then goto _16;
  if ( YY < (-D20T4) ) 
   then goto _15;
  C := 1.0;
  if ( YY-2.0 ) < 0
   then goto _4
   else if ( YY-2.0 ) > 0
         then goto _1
         else goto _1;
_1:
  if ( YY-3.0 ) < 0
   then goto _6
   else if ( YY-3.0 ) > 0
         then goto _2
         else goto _6;
_2:
  if ( YY-10.0 ) < 0
   then goto _3
   else if ( YY-10.0 ) > 0
         then goto _9
         else goto _3;
_3:
  YY := YY-1.0;
  C := C*YY;
  if ( YY-3.0 ) < 0
   then goto _6
   else if ( YY-3.0 ) > 0
         then goto _3
         else goto _6;
_4:
  C := C*YY;
  YY := YY+1.0;
  if ( YY = 0.0 ) 
   then goto _16;
  if ( YY-2.0 ) < 0
   then goto _4
   else if ( YY-2.0 ) > 0
         then goto _5
         else goto _5;
_5:
  C := 1.0/C;
_6:
  B := YY-2.0;
  G := ((((((((((((((-0.5113262726698e-6*B+0.51063592072582e-5)
    *B-0.248410053848712e-4)*B+0.815530498066373e-4)*B-
    0.206447631915933e-3)*B+0.467767811496496e-3)*B-
    0.908346557420052e-3)*B+0.20997590350771e-2)*B-0.28515012430346e-2)*
    B+0.11153819671907e-1)*
    B-0.266951028755527e-3)*B+0.074249007943401e0 )*B+0.81576919401389e-1)*B+
    0.41184033042198e0)*B+0.42278433509852e0 )*B+0.99999999999999e0;
  G := G*C;
  if ( J-2 ) < 0
   then goto _7
   else if ( J-2 ) > 0
         then goto _8
         else goto _7;
_7:
  AA := AA*G;
  goto _12;
_8:
  AA := AA/G;
  goto _12;
_9:
  D := 1.0/YY;
  C := D*D;
  G := (((((((((-1.3924322169059e0*C+0.17964437236883e0)*C-0.029550653594771e0)
    *C+0.0064102564102564e0)*
    C-0.0019175269175269e0)*C+0.841750841750842e-3)*C-0.595238095238095e-3)
    *C+0.793650793650794e-3)*C-0.0027777777777778e0)*C+0.083333333333333e0)*
    D+0.91893853320467e0+(YY-0.5)*Ln(YY)-YY;
  if ( J-2 ) < 0
   then goto _10
   else if ( J-2 ) > 0
         then goto _11
         else goto _10;
_10:
  BB := BB+G;
  goto _12;
_11:
  BB := BB-G;
_12:
 end;
if ( BB ) < 0
 then goto _13
 else if ( BB ) > 0
       then goto _13
       else goto _14;
_13:
AA := AA*Exp(BB);
_14:
Result := AA;
goto _18;
_15:
IERR := 66;
goto _17;
_16:
IERR := 65;
_17:
UTSF10(IERR,22);
Result := SYS059;
_18:
exit;
end;

end.
